diff mbox

[04/15,v2] btrfs: new case to run btrfs balance and remount with different compress algorithms

Message ID 1409233676-22787-5-git-send-email-eguan@redhat.com (mailing list archive)
State New, archived
Headers show

Commit Message

Eryu Guan Aug. 28, 2014, 1:47 p.m. UTC
Run btrfs balance and remount with different compress algorithms
simultaneously, with fsstress running in background.

Signed-off-by: Eryu Guan <eguan@redhat.com>
---
 common/rc           |  10 ++++
 tests/btrfs/062     | 128 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/062.out |   2 +
 tests/btrfs/group   |   1 +
 4 files changed, 141 insertions(+)
 create mode 100755 tests/btrfs/062
 create mode 100644 tests/btrfs/062.out

Comments

Dave Chinner Sept. 8, 2014, 10:08 a.m. UTC | #1
On Thu, Aug 28, 2014 at 09:47:45PM +0800, Eryu Guan wrote:
> Run btrfs balance and remount with different compress algorithms
> simultaneously, with fsstress running in background.
> 
> Signed-off-by: Eryu Guan <eguan@redhat.com>
> ---
>  common/rc           |  10 ++++
>  tests/btrfs/062     | 128 ++++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/btrfs/062.out |   2 +
>  tests/btrfs/group   |   1 +
>  4 files changed, 141 insertions(+)
>  create mode 100755 tests/btrfs/062
>  create mode 100644 tests/btrfs/062.out
> 
> diff --git a/common/rc b/common/rc
> index b0f5064..b5fc1c8 100644
> --- a/common/rc
> +++ b/common/rc
> @@ -2424,6 +2424,16 @@ _btrfs_stress_defrag()
>  	done
>  }
>  
> +_btrfs_stress_remount()
> +{
> +	local btrfs_mnt=$1
> +	while true; do
> +		for algo in no zlib lzo; do
> +			$MOUNT_PROG -o remount,compress=$algo $btrfs_mnt
> +		done
> +	done
> +}

This has nothing to do with "stress" - it tries 3
different compression algorithms. What is the purpose of
this (comments, please!), and can you us a more descriptive name?

> +# test case array
> +tcs=(
> +	"-m single -d single"
> +	"-m dup -d single"
> +	"-m raid0 -d raid0"
> +	"-m raid1 -d raid0"
> +	"-m raid1 -d raid1"
> +	"-m raid10 -d raid10"
> +	"-m raid5 -d raid5"
> +	"-m raid6 -d raid6"
> +)

This is pretty common, right? Perhaps this should be a config
variable that can be overridden by the config file configuration?

Cheers,

Dave.
Eryu Guan Sept. 9, 2014, 1:06 p.m. UTC | #2
On Mon, Sep 08, 2014 at 08:08:59PM +1000, Dave Chinner wrote:
> On Thu, Aug 28, 2014 at 09:47:45PM +0800, Eryu Guan wrote:
> > Run btrfs balance and remount with different compress algorithms
> > simultaneously, with fsstress running in background.
> > 
> > Signed-off-by: Eryu Guan <eguan@redhat.com>
> > ---
> >  common/rc           |  10 ++++
> >  tests/btrfs/062     | 128 ++++++++++++++++++++++++++++++++++++++++++++++++++++
> >  tests/btrfs/062.out |   2 +
> >  tests/btrfs/group   |   1 +
> >  4 files changed, 141 insertions(+)
> >  create mode 100755 tests/btrfs/062
> >  create mode 100644 tests/btrfs/062.out
> > 
> > diff --git a/common/rc b/common/rc
> > index b0f5064..b5fc1c8 100644
> > --- a/common/rc
> > +++ b/common/rc
> > @@ -2424,6 +2424,16 @@ _btrfs_stress_defrag()
> >  	done
> >  }
> >  
> > +_btrfs_stress_remount()
> > +{
> > +	local btrfs_mnt=$1
> > +	while true; do
> > +		for algo in no zlib lzo; do
> > +			$MOUNT_PROG -o remount,compress=$algo $btrfs_mnt
> > +		done
> > +	done
> > +}
> 
> This has nothing to do with "stress" - it tries 3
> different compression algorithms. What is the purpose of

Yes, it remount with 3 different compression algorithms, and it keeps
doing this in a loop. With fsstress running at background it may
exercise the compression path and to ensure no deadlock when switching
compression algorithm with constant I/O activity.

> this (comments, please!), and can you us a more descriptive name?

Will try, but I don't think I'm good at this :)

> 
> > +# test case array
> > +tcs=(
> > +	"-m single -d single"
> > +	"-m dup -d single"
> > +	"-m raid0 -d raid0"
> > +	"-m raid1 -d raid0"
> > +	"-m raid1 -d raid1"
> > +	"-m raid10 -d raid10"
> > +	"-m raid5 -d raid5"
> > +	"-m raid6 -d raid6"
> > +)
> 
> This is pretty common, right? Perhaps this should be a config
> variable that can be overridden by the config file configuration?

I'm thinking about adding something like this to common/rc or common/btrfs

_btrfs_get_profile_configs()
{
	# need one argument to tell if device-replace is one of the operations
	# if so, export configs without raid5/raid6, and without "-m dup -d single")

	# export tcs array according to some config variable
	# e.g. BTRFS_PROFILE_CONFIG
	# if the var is set, just export it(and _notrun if the configs are not suitable for the test)
	# if the var is not set, export the default configs
}

And call "_btrfs_get_profile_configs replace" or
"_btrfs_get_profile_configs noreplace" in each test to get the test
array setup.

Any thoughts?

Thanks,
Eryu
> 
> Cheers,
> 
> Dave.
> -- 
> Dave Chinner
> david@fromorbit.com
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/common/rc b/common/rc
index b0f5064..b5fc1c8 100644
--- a/common/rc
+++ b/common/rc
@@ -2424,6 +2424,16 @@  _btrfs_stress_defrag()
 	done
 }
 
+_btrfs_stress_remount()
+{
+	local btrfs_mnt=$1
+	while true; do
+		for algo in no zlib lzo; do
+			$MOUNT_PROG -o remount,compress=$algo $btrfs_mnt
+		done
+	done
+}
+
 init_rc()
 {
 	if [ "$iam" == new ]
diff --git a/tests/btrfs/062 b/tests/btrfs/062
new file mode 100755
index 0000000..fbf6d8f
--- /dev/null
+++ b/tests/btrfs/062
@@ -0,0 +1,128 @@ 
+#! /bin/bash
+# FSQA Test No. btrfs/062
+#
+# Run btrfs balance and remount with different compress algorithms
+# simultaneously, with fsstress running in background.
+#
+#-----------------------------------------------------------------------
+# Copyright (C) 2014 Red Hat Inc. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -fr $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+_require_scratch_dev_pool 4
+
+rm -f $seqres.full
+
+# test case array
+tcs=(
+	"-m single -d single"
+	"-m dup -d single"
+	"-m raid0 -d raid0"
+	"-m raid1 -d raid0"
+	"-m raid1 -d raid1"
+	"-m raid10 -d raid10"
+	"-m raid5 -d raid5"
+	"-m raid6 -d raid6"
+)
+
+run_test()
+{
+	local mkfs_opts=$1
+
+	echo "Test $mkfs_opts" >>$seqres.full
+
+	# dup only works on single device
+	if [[ "$mkfs_opts" =~ dup ]]; then
+		_scratch_mkfs $mkfs_opts >>$seqres.full 2>&1
+	else
+		_scratch_pool_mkfs $mkfs_opts >>$seqres.full 2>&1
+	fi
+	# make sure we created btrfs with desired options
+	if [ $? -ne 0 ]; then
+		echo "mkfs $mkfs_opts failed"
+		return
+	fi
+	_scratch_mount >>$seqres.full 2>&1
+
+	args=`_scale_fsstress_args -p 20 -n 100 $FSSTRESS_AVOID -d $SCRATCH_MNT/stressdir`
+	echo "Run fsstress $args" >>$seqres.full
+	$FSSTRESS_PROG $args >/dev/null 2>&1 &
+	fsstress_pid=$!
+
+	echo -n "Start balance worker: " >>$seqres.full
+	_btrfs_stress_balance $SCRATCH_MNT >/dev/null 2>&1 &
+	balance_pid=$!
+	echo "$balance_pid" >>$seqres.full
+
+	echo -n "Start remount worker: " >>$seqres.full
+	_btrfs_stress_remount $SCRATCH_MNT >/dev/null 2>&1 &
+	remount_pid=$!
+	echo "$remount_pid" >>$seqres.full
+
+	echo "Wait for fsstress to exit and kill all background workers" >>$seqres.full
+	wait $fsstress_pid
+	kill $balance_pid $remount_pid
+	wait
+	# wait for the balance and remount loop to finish
+	while ps aux | grep "balance start" | grep -qv grep; do
+		sleep 1
+	done
+	while ps aux | grep "mount.*$SCRATCH_MNT" | grep -qv grep; do
+		sleep 1
+	done
+
+	echo "Scrub the filesystem" >>$seqres.full
+	$BTRFS_UTIL_PROG scrub start -B $SCRATCH_MNT >>$seqres.full 2>&1
+	if [ $? -ne 0 ]; then
+		echo "Scrub find errors in \"$mkfs_opts\" test" | tee -a $seqres.full
+	fi
+
+	$BTRFS_UTIL_PROG filesystem sync $SCRATCH_MNT >/dev/null 2>&1
+	_scratch_unmount
+	_check_scratch_fs
+}
+
+echo "Silence is golden"
+for t in "${tcs[@]}"; do
+	run_test "$t"
+done
+
+status=0
+exit
diff --git a/tests/btrfs/062.out b/tests/btrfs/062.out
new file mode 100644
index 0000000..a1578f4
--- /dev/null
+++ b/tests/btrfs/062.out
@@ -0,0 +1,2 @@ 
+QA output created by 062
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 85d30b3..7aa9bf3 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -64,3 +64,4 @@ 
 059 auto balance subvol
 060 auto balance scrub
 061 auto balance defrag compress
+062 auto balance remount compress